#import <Foundation/NSObject.h>
#import <AppKit/NSNibDeclarations.h>

@class NSPanel;
@class NSProgressIndicator;
@class NSTextField;
@class NSTableView;
@class MVChatConnection;

@interface MVConnectionsController : NSWindowController {
@private
	IBOutlet NSTableView *connections;
	IBOutlet NSWindow *editConnection;
	IBOutlet NSPanel *joinRoom;
	IBOutlet NSPanel *messageUser;
	IBOutlet NSPanel *nicknameAuth;

	/* Nick Auth */
	IBOutlet NSTextField *authNickname;
	IBOutlet NSTextField *authAddress;
	IBOutlet NSTextField *authPassword;

	/* Edit Connection */
	IBOutlet NSTextField *editNickname;
	IBOutlet NSTextField *editPassword;
	IBOutlet NSTextField *editServerPassword;
	IBOutlet NSTextField *editAddress;
	IBOutlet NSTextField *editPort;
    IBOutlet NSButton *editAutomatic;
    IBOutlet NSButton *editRemember;
	IBOutlet NSTableView *editRooms;
	IBOutlet NSButton *editRemoveRoom;
    IBOutlet NSButton *editOKButton;

	/* Join Room & Message User */
	IBOutlet NSComboBox *roomToJoin;
	IBOutlet NSTextField *roomPassword;
	IBOutlet NSTextField *userToMessage;

	NSMutableArray *_bookmarks;
    SInt16 _editingRow;
    SInt16 _editingDefaultsRow;
	NSMutableArray *_editingRooms;
	MVChatConnection *_passConnection;
}
+ (MVConnectionsController *) defaultManager;

- (IBAction) showConnectionManager:(id) sender;

- (IBAction) newConnection:(id) sender;

- (IBAction) messageUser:(id) sender;
- (IBAction) joinRoom:(id) sender;

- (IBAction) editConnection:(id) sender;
- (IBAction) addRoom:(id) sender;
- (IBAction) removeRoom:(id) sender;

- (IBAction) sendPassword:(id) sender;

- (void) handleURL:(NSURL *) url andConnectIfPossible:(BOOL) connect;
@end
