#import <Security/Security.h>
#import <Foundation/NSObject.h>

@class NSString;


/*
 * Storing data/passwords to any other Keychain than
 * the default Keychain isn't supported yet.
 *
 * Creating or deleting a Keychain isn't supported yet.
 *
 * Internet passwords are supported so far, only.
 */


@interface MVKeyChain : NSObject {
}
+ (MVKeyChain *) defaultKeyChain;

/*
 * This will:
 *
 *  - set a new Internet password if there isn't one yet for the
 *    given server/account/port/protocol combination.
 *
 *  - change the password for a given combination if there
 *    already exists one without resetting the password's attributes.
 *
 *  - remove a password if a nil or empty password string is given.
 *    This makes sense since Keychain won't accept empty passwords.
 */
- (void) setInternetPassword:(NSString *) password forServer:(NSString *) server account:(NSString *) account port:(unsigned short) port protocol:(SecProtocolType) protocol;
/*
 * This will look up an internet password or return nilö if there is none.
 */
- (NSString *) internetPasswordForServer:(NSString *) server account:(NSString *) account port:(unsigned short) port protocol:(SecProtocolType) protocol;

@end
